var time = 5000;
var rand = Math.floor(Math.random() * 10000);
var L = 64;
var R = 512 - 64;
var T = 0;
var B = 384; /* osu height=384 width=512 */
var fileoutname = "Blizzard Entertainment - Radio Free Zerg ([CSGA]Ar3sgice) [" + "RandomPictureMap_" + rand + "].osu";
var prefsname = "prefs.osh";
var versionInfo = "RandomPictureMap_" + rand;
var bmpLineOffset = 0;
var colorLimit = 8;

var fso = new ActiveXObject("Scripting.FileSystemObject");
var fi = fso.OpenTextFile("FileIn.txt");
var fdata = fi.ReadAll();
fdata = fdata.replace(/[^0-9a-fA-F]/ig,"");
var header = fdata.substr(0,0x36*2);
var fwidth = parseInt(header.substr(36,2),16);
var fheight = parseInt(header.substr(44,2),16);
var rgb_data = fdata.substr(0x36*2,fdata.length - 0x36*2);
var rgb_data2 = "";
var colors = [];
var p = 0;
var cs = "";
var ci = 0;
for(var k=0;k<fheight;k++)
{
	for(var j=0;j<fwidth;j++)
	{
		cs = rgb_data.substr(p,6);
		ci = 0;
		if(cs.length<6)
		{
			break;
		}
		if(cs == "000000")
		{
			ci = "X";
		}
		else
		{
			for(var i=0;i<colors.length;i++)
			{
				if(colors[i] == cs)
				{
					ci = 1+i;
					break;
				}
			}
			if(!ci)
			{
				if(colors.length >= colorLimit)
				{
					WScript.Echo("more than " + colorLimit + " colors: " + colors);
					WScript.Quit();
				}
				ci = colors.push(cs);
			}
		}
		rgb_data2 += ci;
		p += 6;
	}
	p += bmpLineOffset;
}
rgb_data = rgb_data.replace(/000000/ig,"");
var combo_colors = "[Colours]";
for(var i=0;i<colors.length;i++)
{
	combo_colors += "\r\nCombo" + (1+i) + " : " + parseInt(colors[i].substr(4,2),16) + "," + parseInt(colors[i].substr(2,2),16) + "," + parseInt(colors[i].substr(0,2),16);
}
rgb_data = rgb_data2;
var out = "[HitObjects]";
for(var i=0;i<colors.length-1;i++)
{
	out += "\r\n0,0,"+(1+i)+",5,0";
}
var flag = 5;
for(var j=1;j<=colorLimit;j++)
{
	flag = 5;
	for(var i=0;i<rgb_data.length;i++)
	{
		if(rgb_data.charAt(i) == j)
		{
			out += "\r\n";
			out += Math.round(L + ((i % fwidth)/(fwidth-1)) * (R-L));
			out += ",";
			out += Math.round(B - ((i - i % fwidth)/(fwidth) / (fheight-1)) * (B-T));
			out += ",";
			out += time + 2*j - (flag==5?1:0);
			out += ",";
			out += flag;
			out += ",0";
			flag = 1;
		}
	}
}
var fp2 = fso.OpenTextFile(prefsname);
var fp2data = fp2.ReadAll();
fp2data = fp2data.replace("VERSION_TEXT_HERE",versionInfo);
out = fp2data + "\r\n\r\n" + combo_colors + "\r\n\r\n" + out;
var outfile = fso.CreateTextFile(fileoutname);
outfile.Write(out);
outfile.Close();
/* WScript.Echo(colors); */
WScript.Quit();